diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-direct.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-direct.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-direct.php	2012-12-20 09:55:32.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-direct.php	2013-09-21 23:44:10.000000000 -0500
***************
*** 15,21 ****
   * @uses WP_Filesystem_Base Extends class
   */
  class WP_Filesystem_Direct extends WP_Filesystem_Base {
! 	var $errors = null;
  	/**
  	 * constructor
  	 *
--- 15,21 ----
   * @uses WP_Filesystem_Base Extends class
   */
  class WP_Filesystem_Direct extends WP_Filesystem_Base {
! 
  	/**
  	 * constructor
  	 *
***************
*** 25,38 ****
  		$this->method = 'direct';
  		$this->errors = new WP_Error();
  	}
! 	/**
! 	 * connect filesystem.
! 	 *
! 	 * @return bool Returns true on success or false on failure (always true for WP_Filesystem_Direct).
! 	 */
! 	function connect() {
! 		return true;
! 	}
  	/**
  	 * Reads entire file into a string
  	 *
--- 25,31 ----
  		$this->method = 'direct';
  		$this->errors = new WP_Error();
  	}
! 
  	/**
  	 * Reads entire file into a string
  	 *
***************
*** 59,72 ****
  	 * @param int $mode (optional) The file permissions as octal number, usually 0644.
  	 * @return bool False upon failure.
  	 */
! 	function put_contents($file, $contents, $mode = false ) {
! 		if ( ! ($fp = @fopen($file, 'w')) )
  			return false;
! 		@fwrite($fp, $contents);
! 		@fclose($fp);
! 		$this->chmod($file, $mode);
  		return true;
  	}
  	/**
  	 * Gets the current working directory
  	 *
--- 54,82 ----
  	 * @param int $mode (optional) The file permissions as octal number, usually 0644.
  	 * @return bool False upon failure.
  	 */
! 	function put_contents( $file, $contents, $mode = false ) {
! 		$fp = @fopen( $file, 'wb' );
! 		if ( ! $fp )
! 			return false;
! 
! 		mbstring_binary_safe_encoding();
! 
! 		$data_length = strlen( $contents );
! 
! 		$bytes_written = fwrite( $fp, $contents );
! 
! 		reset_mbstring_encoding();
! 
! 		fclose( $fp );
! 
! 		if ( $data_length !== $bytes_written )
  			return false;
! 
! 		$this->chmod( $file, $mode );
! 
  		return true;
  	}
+ 
  	/**
  	 * Gets the current working directory
  	 *
***************
*** 99,105 ****
  			return @chgrp($file, $group);
  		if ( ! $this->is_dir($file) )
  			return @chgrp($file, $group);
! 		//Is a directory, and we want recursive
  		$file = trailingslashit($file);
  		$filelist = $this->dirlist($file);
  		foreach ($filelist as $filename)
--- 111,117 ----
  			return @chgrp($file, $group);
  		if ( ! $this->is_dir($file) )
  			return @chgrp($file, $group);
! 		// Is a directory, and we want recursive
  		$file = trailingslashit($file);
  		$filelist = $this->dirlist($file);
  		foreach ($filelist as $filename)
***************
*** 127,133 ****
  
  		if ( ! $recursive || ! $this->is_dir($file) )
  			return @chmod($file, $mode);
! 		//Is a directory, and we want recursive
  		$file = trailingslashit($file);
  		$filelist = $this->dirlist($file);
  		foreach ( (array)$filelist as $filename => $filemeta)
--- 140,146 ----
  
  		if ( ! $recursive || ! $this->is_dir($file) )
  			return @chmod($file, $mode);
! 		// Is a directory, and we want recursive
  		$file = trailingslashit($file);
  		$filelist = $this->dirlist($file);
  		foreach ( (array)$filelist as $filename => $filemeta)
***************
*** 150,156 ****
  			return @chown($file, $owner);
  		if ( ! $this->is_dir($file) )
  			return @chown($file, $owner);
! 		//Is a directory, and we want recursive
  		$filelist = $this->dirlist($file);
  		foreach ($filelist as $filename) {
  			$this->chown($file . '/' . $filename, $owner, $recursive);
--- 164,170 ----
  			return @chown($file, $owner);
  		if ( ! $this->is_dir($file) )
  			return @chown($file, $owner);
! 		// Is a directory, and we want recursive
  		$filelist = $this->dirlist($file);
  		foreach ($filelist as $filename) {
  			$this->chown($file . '/' . $filename, $owner, $recursive);
***************
*** 161,167 ****
  	 * Gets file owner
  	 *
  	 * @param string $file Path to the file.
! 	 * @return string Username of the user.
  	 */
  	function owner($file) {
  		$owneruid = @fileowner($file);
--- 176,182 ----
  	 * Gets file owner
  	 *
  	 * @param string $file Path to the file.
! 	 * @return string|bool Username of the user or false on error.
  	 */
  	function owner($file) {
  		$owneruid = @fileowner($file);
***************
*** 220,243 ****
  	}
  
  	function delete($file, $recursive = false, $type = false) {
! 		if ( empty($file) ) //Some filesystems report this as /, which can cause non-expected recursive deletion of all files in the filesystem.
  			return false;
! 		$file = str_replace('\\', '/', $file); //for win32, occasional problems deleting files otherwise
  
  		if ( 'f' == $type || $this->is_file($file) )
  			return @unlink($file);
  		if ( ! $recursive && $this->is_dir($file) )
  			return @rmdir($file);
  
! 		//At this point it's a folder, and we're in recursive mode
  		$file = trailingslashit($file);
  		$filelist = $this->dirlist($file, true);
  
  		$retval = true;
! 		if ( is_array($filelist) ) //false if no files, So check first.
! 			foreach ($filelist as $filename => $fileinfo)
  				if ( ! $this->delete($file . $filename, $recursive, $fileinfo['type']) )
  					$retval = false;
  
  		if ( file_exists($file) && ! @rmdir($file) )
  			$retval = false;
--- 237,262 ----
  	}
  
  	function delete($file, $recursive = false, $type = false) {
! 		if ( empty( $file ) ) // Some filesystems report this as /, which can cause non-expected recursive deletion of all files in the filesystem.
  			return false;
! 		$file = str_replace( '\\', '/', $file ); // for win32, occasional problems deleting files otherwise
  
  		if ( 'f' == $type || $this->is_file($file) )
  			return @unlink($file);
  		if ( ! $recursive && $this->is_dir($file) )
  			return @rmdir($file);
  
! 		// At this point it's a folder, and we're in recursive mode
  		$file = trailingslashit($file);
  		$filelist = $this->dirlist($file, true);
  
  		$retval = true;
! 		if ( is_array( $filelist ) ) {
! 			foreach ( $filelist as $filename => $fileinfo ) {
  				if ( ! $this->delete($file . $filename, $recursive, $fileinfo['type']) )
  					$retval = false;
+ 			}
+ 		}
  
  		if ( file_exists($file) && ! @rmdir($file) )
  			$retval = false;
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-ftpext.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-ftpext.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-ftpext.php	2012-07-06 06:39:39.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-ftpext.php	2013-09-21 23:44:10.000000000 -0500
***************
*** 23,36 ****
  		$this->method = 'ftpext';
  		$this->errors = new WP_Error();
  
! 		//Check if possible to use ftp functions.
  		if ( ! extension_loaded('ftp') ) {
  			$this->errors->add('no_ftp_ext', __('The ftp PHP extension is not available'));
  			return false;
  		}
  
! 		// Set defaults:
! 		//This Class uses the timeout on a per-connection basis, Others use it on a per-action basis.
  
  		if ( ! defined('FS_TIMEOUT') )
  			define('FS_TIMEOUT', 240);
--- 23,35 ----
  		$this->method = 'ftpext';
  		$this->errors = new WP_Error();
  
! 		// Check if possible to use ftp functions.
  		if ( ! extension_loaded('ftp') ) {
  			$this->errors->add('no_ftp_ext', __('The ftp PHP extension is not available'));
  			return false;
  		}
  
! 		// This Class uses the timeout on a per-connection basis, Others use it on a per-action basis.
  
  		if ( ! defined('FS_TIMEOUT') )
  			define('FS_TIMEOUT', 240);
***************
*** 80,86 ****
  			return false;
  		}
  
! 		//Set the Connection to use Passive FTP
  		@ftp_pasv( $this->link, true );
  		if ( @ftp_get_option($this->link, FTP_TIMEOUT_SEC) < FS_TIMEOUT )
  			@ftp_set_option($this->link, FTP_TIMEOUT_SEC, FS_TIMEOUT);
--- 79,85 ----
  			return false;
  		}
  
! 		// Set the Connection to use Passive FTP
  		@ftp_pasv( $this->link, true );
  		if ( @ftp_get_option($this->link, FTP_TIMEOUT_SEC) < FS_TIMEOUT )
  			@ftp_set_option($this->link, FTP_TIMEOUT_SEC, FS_TIMEOUT);
***************
*** 88,107 ****
  		return true;
  	}
  
! 	function get_contents($file, $type = '', $resumepos = 0 ) {
! 		if ( empty($type) )
! 			$type = FTP_BINARY;
! 
  		$tempfile = wp_tempnam($file);
  		$temp = fopen($tempfile, 'w+');
  
  		if ( ! $temp )
  			return false;
  
! 		if ( ! @ftp_fget($this->link, $temp, $file, $type, $resumepos) )
  			return false;
  
! 		fseek($temp, 0); //Skip back to the start of the file being written to
  		$contents = '';
  
  		while ( ! feof($temp) )
--- 87,103 ----
  		return true;
  	}
  
! 	function get_contents( $file ) {
  		$tempfile = wp_tempnam($file);
  		$temp = fopen($tempfile, 'w+');
  
  		if ( ! $temp )
  			return false;
  
! 		if ( ! @ftp_fget($this->link, $temp, $file, FTP_BINARY ) )
  			return false;
  
! 		fseek( $temp, 0 ); // Skip back to the start of the file being written to
  		$contents = '';
  
  		while ( ! feof($temp) )
***************
*** 117,131 ****
  
  	function put_contents($file, $contents, $mode = false ) {
  		$tempfile = wp_tempnam($file);
! 		$temp = fopen($tempfile, 'w+');
  		if ( ! $temp )
  			return false;
  
! 		fwrite($temp, $contents);
! 		fseek($temp, 0); //Skip back to the start of the file being written to
  
! 		$type = $this->is_binary($contents) ? FTP_BINARY : FTP_ASCII;
! 		$ret = @ftp_fput($this->link, $file, $temp, $type);
  
  		fclose($temp);
  		unlink($tempfile);
--- 114,139 ----
  
  	function put_contents($file, $contents, $mode = false ) {
  		$tempfile = wp_tempnam($file);
! 		$temp = fopen( $tempfile, 'wb+' );
  		if ( ! $temp )
  			return false;
  
! 		mbstring_binary_safe_encoding();
! 
! 		$data_length = strlen( $contents );
! 		$bytes_written = fwrite( $temp, $contents );
! 
! 		reset_mbstring_encoding();
! 
! 		if ( $data_length !== $bytes_written ) {
! 			fclose( $temp );
! 			unlink( $tempfile );
! 			return false;
! 		}
  
! 		fseek( $temp, 0 ); // Skip back to the start of the file being written to
! 
! 		$ret = @ftp_fput( $this->link, $file, $temp, FTP_BINARY );
  
  		fclose($temp);
  		unlink($tempfile);
***************
*** 168,176 ****
  			return (bool)@ftp_site($this->link, sprintf('CHMOD %o %s', $mode, $file));
  		return (bool)@ftp_chmod($this->link, $mode, $file);
  	}
! 	function chown($file, $owner, $recursive = false ) {
! 		return false;
! 	}
  	function owner($file) {
  		$dir = $this->dirlist($file);
  		return $dir[$file]['owner'];
--- 180,186 ----
  			return (bool)@ftp_site($this->link, sprintf('CHMOD %o %s', $mode, $file));
  		return (bool)@ftp_chmod($this->link, $mode, $file);
  	}
! 
  	function owner($file) {
  		$dir = $this->dirlist($file);
  		return $dir[$file]['owner'];
***************
*** 187,193 ****
  		if ( ! $overwrite && $this->exists($destination) )
  			return false;
  		$content = $this->get_contents($source);
! 		if ( false === $content)
  			return false;
  		return $this->put_contents($destination, $content, $mode);
  	}
--- 200,206 ----
  		if ( ! $overwrite && $this->exists($destination) )
  			return false;
  		$content = $this->get_contents($source);
! 		if ( false === $content )
  			return false;
  		return $this->put_contents($destination, $content, $mode);
  	}
***************
*** 226,239 ****
  		}
  		return false;
  	}
  	function is_readable($file) {
- 		//Get dir list, Check if the file is readable by the current user??
  		return true;
  	}
  	function is_writable($file) {
- 		//Get dir list, Check if the file is writable by the current user??
  		return true;
  	}
  	function atime($file) {
  		return false;
  	}
--- 242,256 ----
  		}
  		return false;
  	}
+ 
  	function is_readable($file) {
  		return true;
  	}
+ 
  	function is_writable($file) {
  		return true;
  	}
+ 
  	function atime($file) {
  		return false;
  	}
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-ftpsockets.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-ftpsockets.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-ftpsockets.php	2012-12-20 09:55:32.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-ftpsockets.php	2013-09-21 23:44:10.000000000 -0500
***************
*** 23,34 ****
  		$this->method = 'ftpsockets';
  		$this->errors = new WP_Error();
  
! 		//Check if possible to use ftp functions.
  		if ( ! @include_once ABSPATH . 'wp-admin/includes/class-ftp.php' )
  				return false;
  		$this->ftp = new ftp();
  
- 		//Set defaults:
  		if ( empty($opt['port']) )
  			$this->options['port'] = 21;
  		else
--- 23,33 ----
  		$this->method = 'ftpsockets';
  		$this->errors = new WP_Error();
  
! 		// Check if possible to use ftp functions.
  		if ( ! @include_once ABSPATH . 'wp-admin/includes/class-ftp.php' )
  				return false;
  		$this->ftp = new ftp();
  
  		if ( empty($opt['port']) )
  			$this->options['port'] = 21;
  		else
***************
*** 75,106 ****
  			return false;
  		}
  
! 		$this->ftp->SetType(FTP_AUTOASCII);
! 		$this->ftp->Passive(true);
! 		$this->ftp->setTimeout(FS_TIMEOUT);
  		return true;
  	}
  
! 	function get_contents($file, $type = '', $resumepos = 0) {
  		if ( ! $this->exists($file) )
  			return false;
  
- 		if ( empty($type) )
- 			$type = FTP_AUTOASCII;
- 		$this->ftp->SetType($type);
- 
  		$temp = wp_tempnam( $file );
  
  		if ( ! $temphandle = fopen($temp, 'w+') )
  			return false;
  
  		if ( ! $this->ftp->fget($temphandle, $file) ) {
  			fclose($temphandle);
  			unlink($temp);
! 			return ''; //Blank document, File does exist, It's just blank.
  		}
  
! 		fseek($temphandle, 0); //Skip back to the start of the file being written to
  		$contents = '';
  
  		while ( ! feof($temphandle) )
--- 74,108 ----
  			return false;
  		}
  
! 		$this->ftp->SetType( FTP_BINARY );
! 		$this->ftp->Passive( true );
! 		$this->ftp->setTimeout( FS_TIMEOUT );
  		return true;
  	}
  
! 	function get_contents( $file ) {
  		if ( ! $this->exists($file) )
  			return false;
  
  		$temp = wp_tempnam( $file );
  
  		if ( ! $temphandle = fopen($temp, 'w+') )
  			return false;
  
+ 		mbstring_binary_safe_encoding();
+ 
  		if ( ! $this->ftp->fget($temphandle, $file) ) {
  			fclose($temphandle);
  			unlink($temp);
! 
! 			reset_mbstring_encoding();
! 
! 			return ''; // Blank document, File does exist, It's just blank.
  		}
  
! 		reset_mbstring_encoding();
! 
! 		fseek( $temphandle, 0 ); // Skip back to the start of the file being written to
  		$contents = '';
  
  		while ( ! feof($temphandle) )
***************
*** 122,135 ****
  			return false;
  		}
  
! 		fwrite($temphandle, $contents);
! 		fseek($temphandle, 0); //Skip back to the start of the file being written to
  
! 		$type = $this->is_binary($contents) ? FTP_BINARY : FTP_ASCII;
! 		$this->ftp->SetType($type);
  
  		$ret = $this->ftp->fput($file, $temphandle);
  
  		fclose($temphandle);
  		unlink($temp);
  
--- 124,148 ----
  			return false;
  		}
  
! 		// The FTP class uses string functions internally during file download/upload
! 		mbstring_binary_safe_encoding();
! 
! 		$bytes_written = fwrite( $temphandle, $contents );
! 		if ( false === $bytes_written || $bytes_written != strlen( $contents ) ) {
! 			fclose( $temphandle );
! 			unlink( $temp );
! 
! 			reset_mbstring_encoding();
! 
! 			return false;
! 		}
  
! 		fseek( $temphandle, 0 ); // Skip back to the start of the file being written to
  
  		$ret = $this->ftp->fput($file, $temphandle);
  
+ 		reset_mbstring_encoding();
+ 
  		fclose($temphandle);
  		unlink($temp);
  
***************
*** 174,183 ****
  		return $this->ftp->chmod($file, $mode);
  	}
  
- 	function chown($file, $owner, $recursive = false ) {
- 		return false;
- 	}
- 
  	function owner($file) {
  		$dir = $this->dirlist($file);
  		return $dir[$file]['owner'];
--- 187,192 ----
***************
*** 219,226 ****
  		return $this->ftp->mdel($file);
  	}
  
! 	function exists($file) {
! 		return $this->ftp->is_exists($file);
  	}
  
  	function is_file($file) {
--- 228,237 ----
  		return $this->ftp->mdel($file);
  	}
  
! 	function exists( $file ) {
! 		$list = $this->ftp->nlist( $file );
! 		return !empty( $list ); //empty list = no file, so invert.
! 		// return $this->ftp->is_exists($file); has issues with ABOR+426 responses on the ncFTPd server
  	}
  
  	function is_file($file) {
***************
*** 241,252 ****
  	}
  
  	function is_readable($file) {
- 		//Get dir list, Check if the file is writable by the current user??
  		return true;
  	}
  
  	function is_writable($file) {
- 		//Get dir list, Check if the file is writable by the current user??
  		return true;
  	}
  
--- 252,261 ----
***************
*** 295,303 ****
  			$limit_file = false;
  		}
  
  		$list = $this->ftp->dirlist($path);
! 		if ( empty($list) && !$this->exists($path) )
  			return false;
  
  		$ret = array();
  		foreach ( $list as $struc ) {
--- 304,318 ----
  			$limit_file = false;
  		}
  
+ 		mbstring_binary_safe_encoding();
+ 
  		$list = $this->ftp->dirlist($path);
! 		if ( empty( $list ) && ! $this->exists( $path ) ) {
! 
! 			reset_mbstring_encoding();
! 
  			return false;
+ 		}
  
  		$ret = array();
  		foreach ( $list as $struc ) {
***************
*** 324,329 ****
--- 339,347 ----
  
  			$ret[ $struc['name'] ] = $struc;
  		}
+ 
+ 		reset_mbstring_encoding();
+ 
  		return $ret;
  	}
  
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-ssh2.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-ssh2.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-ssh2.php	2013-07-09 23:15:13.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-ssh2.php	2013-09-21 23:44:10.000000000 -0500
***************
*** 1,13 ****
  <?php
  /**
!  * WordPress SSH2 Filesystem.
!  *
!  * @package WordPress
!  * @subpackage Filesystem
!  */
! 
! /**
!  * WordPress Filesystem Class for implementing SSH2.
   *
   * To use this class you must follow these steps for PHP 5.2.6+
   *
--- 1,6 ----
  <?php
  /**
!  * WordPress Filesystem Class for implementing SSH2
   *
   * To use this class you must follow these steps for PHP 5.2.6+
   *
***************
*** 35,44 ****
   *
   * Note: as of WordPress 2.8, This utilises the PHP5+ function 'stream_get_contents'
   *
!  * @since 2.7
   * @package WordPress
   * @subpackage Filesystem
-  * @uses WP_Filesystem_Base Extends class
   */
  class WP_Filesystem_SSH2 extends WP_Filesystem_Base {
  
--- 28,37 ----
   *
   * Note: as of WordPress 2.8, This utilises the PHP5+ function 'stream_get_contents'
   *
!  * @since 2.7.0
!  *
   * @package WordPress
   * @subpackage Filesystem
   */
  class WP_Filesystem_SSH2 extends WP_Filesystem_Base {
  
***************
*** 150,156 ****
  		return false;
  	}
  
! 	function get_contents($file, $type = '', $resumepos = 0 ) {
  		$file = ltrim($file, '/');
  		return file_get_contents('ssh2.sftp://' . $this->sftp_link . '/' . $file);
  	}
--- 143,149 ----
  		return false;
  	}
  
! 	function get_contents( $file ) {
  		$file = ltrim($file, '/');
  		return file_get_contents('ssh2.sftp://' . $this->sftp_link . '/' . $file);
  	}
***************
*** 161,172 ****
  	}
  
  	function put_contents($file, $contents, $mode = false ) {
! 		$file = ltrim($file, '/');
! 		$ret = file_put_contents('ssh2.sftp://' . $this->sftp_link . '/' . $file, $contents);
  
  		$this->chmod($file, $mode);
  
! 		return false !== $ret;
  	}
  
  	function cwd() {
--- 154,167 ----
  	}
  
  	function put_contents($file, $contents, $mode = false ) {
! 		$ret = file_put_contents( 'ssh2.sftp://' . $this->sftp_link . '/' . ltrim( $file, '/' ), $contents );
! 
! 		if ( $ret !== strlen( $contents ) )
! 			return false;
  
  		$this->chmod($file, $mode);
  
! 		return true;
  	}
  
  	function cwd() {
***************
*** 206,212 ****
  		return $this->run_command(sprintf('chmod -R %o %s', $mode, escapeshellarg($file)), true);
  	}
  
! 	function chown($file, $owner, $recursive = false ) {
  		if ( ! $this->exists($file) )
  			return false;
  		if ( ! $recursive || ! $this->is_dir($file) )
--- 201,217 ----
  		return $this->run_command(sprintf('chmod -R %o %s', $mode, escapeshellarg($file)), true);
  	}
  
! 	/**
! 	 * Change the ownership of a file / folder.
! 	 *
! 	 * @since Unknown
! 	 *
! 	 * @param string $file    Path to the file.
! 	 * @param mixed  $owner   A user name or number.
! 	 * @param bool $recursive Optional. If set True changes file owner recursivly. Defaults to False.
! 	 * @return bool Returns true on success or false on failure.
! 	 */
! 	function chown( $file, $owner, $recursive = false ) {
  		if ( ! $this->exists($file) )
  			return false;
  		if ( ! $recursive || ! $this->is_dir($file) )
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-importer.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-importer.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-importer.php	2013-07-31 01:53:06.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-importer.php	2013-09-05 11:34:09.000000000 -0500
***************
*** 179,185 ****
  	 */
  	function get_page( $url, $username = '', $password = '', $head = false ) {
  		// Increase the timeout
! 		add_filter( 'http_request_timeout', array( &$this, 'bump_request_timeout' ) );
  
  		$headers = array();
  		$args = array();
--- 179,185 ----
  	 */
  	function get_page( $url, $username = '', $password = '', $head = false ) {
  		// Increase the timeout
! 		add_filter( 'http_request_timeout', array( $this, 'bump_request_timeout' ) );
  
  		$headers = array();
  		$args = array();
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-list-table.php	2013-04-28 20:10:50.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-list-table.php	2013-09-23 20:54:09.000000000 -0500
***************
*** 87,93 ****
  
  		$this->screen = convert_to_screen( $args['screen'] );
  
! 		add_filter( "manage_{$this->screen->id}_columns", array( &$this, 'get_columns' ), 0 );
  
  		if ( !$args['plural'] )
  			$args['plural'] = $this->screen->base;
--- 87,93 ----
  
  		$this->screen = convert_to_screen( $args['screen'] );
  
! 		add_filter( "manage_{$this->screen->id}_columns", array( $this, 'get_columns' ), 0 );
  
  		if ( !$args['plural'] )
  			$args['plural'] = $this->screen->base;
***************
*** 99,105 ****
  
  		if ( $args['ajax'] ) {
  			// wp_enqueue_script( 'list-table' );
! 			add_action( 'admin_footer', array( &$this, '_js_vars' ) );
  		}
  	}
  
--- 99,105 ----
  
  		if ( $args['ajax'] ) {
  			// wp_enqueue_script( 'list-table' );
! 			add_action( 'admin_footer', array( $this, '_js_vars' ) );
  		}
  	}
  
***************
*** 340,346 ****
  		if ( !$action_count )
  			return '';
  
! 		$out = '<div class="' . ( $always_visible ? 'row-actions-visible' : 'row-actions' ) . '">';
  		foreach ( $actions as $action => $link ) {
  			++$i;
  			( $i == $action_count ) ? $sep = '' : $sep = ' | ';
--- 340,346 ----
  		if ( !$action_count )
  			return '';
  
! 		$out = '<div class="' . ( $always_visible ? 'row-actions visible' : 'row-actions' ) . '">';
  		foreach ( $actions as $action => $link ) {
  			++$i;
  			( $i == $action_count ) ? $sep = '' : $sep = ' | ';
***************
*** 367,372 ****
--- 367,382 ----
  			ORDER BY post_date DESC
  		", $post_type ) );
  
+ 		/**
+ 		 * Filter the months dropdown results.
+ 		 *
+ 		 * @since 3.7.0
+ 		 *
+ 		 * @param object $months    The months dropdown query results.
+ 		 * @param string $post_type The post type.
+ 		 */
+ 		$months = apply_filters( 'months_dropdown_results', $months, $post_type );
+ 
  		$month_count = count( $months );
  
  		if ( !$month_count || ( 1 == $month_count && 0 == $months[0]->month ) )
***************
*** 764,770 ****
  ?>
  	<div class="tablenav <?php echo esc_attr( $which ); ?>">
  
! 		<div class="alignleft actions">
  			<?php $this->bulk_actions(); ?>
  		</div>
  <?php
--- 774,780 ----
  ?>
  	<div class="tablenav <?php echo esc_attr( $which ); ?>">
  
! 		<div class="alignleft actions bulkactions">
  			<?php $this->bulk_actions(); ?>
  		</div>
  <?php
***************
*** 857,863 ****
  			}
  			elseif ( method_exists( $this, 'column_' . $column_name ) ) {
  				echo "<td $attributes>";
! 				echo call_user_func( array( &$this, 'column_' . $column_name ), $item );
  				echo "</td>";
  			}
  			else {
--- 867,873 ----
  			}
  			elseif ( method_exists( $this, 'column_' . $column_name ) ) {
  				echo "<td $attributes>";
! 				echo call_user_func( array( $this, 'column_' . $column_name ), $item );
  				echo "</td>";
  			}
  			else {
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-media-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-media-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-media-list-table.php	2013-06-01 04:40:00.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-media-list-table.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 301,311 ****
  		break;
  
  	case 'parent':
! 		if ( $post->post_parent > 0 && get_post( $post->post_parent ) ) {
  			$title = _draft_or_post_title( $post->post_parent );
  ?>
  			<td <?php echo $attributes ?>><strong>
! 				<?php if ( current_user_can( 'edit_post', $post->post_parent ) ) { ?>
  					<a href="<?php echo get_edit_post_link( $post->post_parent ); ?>">
  						<?php echo $title ?></a><?php
  				} else {
--- 301,317 ----
  		break;
  
  	case 'parent':
! 		if ( $post->post_parent > 0 )
! 			$parent = get_post( $post->post_parent );
! 		else
! 			$parent = false;
! 
! 		if ( $parent ) {
  			$title = _draft_or_post_title( $post->post_parent );
+ 			$parent_type = get_post_type_object( $parent->post_type );
  ?>
  			<td <?php echo $attributes ?>><strong>
! 				<?php if ( current_user_can( 'edit_post', $post->post_parent ) && $parent_type->show_ui ) { ?>
  					<a href="<?php echo get_edit_post_link( $post->post_parent ); ?>">
  						<?php echo $title ?></a><?php
  				} else {
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-ms-sites-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-ms-sites-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-ms-sites-list-table.php	2013-03-01 11:00:25.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-ms-sites-list-table.php	2013-08-26 13:46:08.000000000 -0500
***************
*** 214,221 ****
--- 214,223 ----
  				switch ( $column_name ) {
  					case 'cb': ?>
  						<th scope="row" class="check-column">
+ 							<?php if ( ! is_main_site( $blog['blog_id'] ) ) : ?>
  							<label class="screen-reader-text" for="blog_<?php echo $blog['blog_id']; ?>"><?php printf( __( 'Select %s' ), $blogname ); ?></label>
  							<input type="checkbox" id="blog_<?php echo $blog['blog_id'] ?>" name="allblogs[]" value="<?php echo esc_attr( $blog['blog_id'] ) ?>" />
+ 							<?php endif; ?>
  						</th>
  					<?php
  					break;
